float[] burnsum;
float burn;
int startyear = 2005;
float weekwidth = 1;
float weekin, weekout, week;
float totalweeks = 650;

float starHeight=500;
float cellheight=50;
float red, green, blue;
float[] temp;

double minburn=0, maxburn=8;

color convection = #66ccff;
color overshoot = #ffffff;
color semiconv = #cccccc;
color thermohaline = #cc66ff;
color rotation = #66ff66;

color minburncolor = #fee0d2;
color maxburncolor = #de2d26;
color mincoolcolor = #deebf7;
color maxcoolcolor = #3182bd;
color cooling = #0000ff;
color burnColor;

color minwindcolor = #ffeda0;
color maxwindcolor = #f03b20;
color windcolor;

color surfaceColor;

void kipp() {
  stroke(255);
  strokeWeight(1);
  line(starHeight/2, -2000, starHeight/2, 2000);
  
  for (int t=0; t < numRows; t++) {
    if (abs(age-t) < 100) {
    pushMatrix();
    float z = (log(dt[t])/log(10)+5)*cellheight;
    translate(-starHeight,(age-t)*cellheight,z/2);
    fill(255);
    //box(cellheight,cellheight,z/2);
    popMatrix();
    stroke(255);
    line(-starHeight/2, -2000, -starHeight/2, 2000);
    stroke(0);
    fill(255,255,0);
    pushMatrix();
    translate(starHeight*(0.5-(float)star_mass[t]),(age-t)*cellheight,0);
    box(1,cellheight,cellheight);
    popMatrix();
    stroke(0);
    for (int i=0; i<numMixRegions; i++) {
     //println(mix_qtop[i][t]);
     if (mix_type[i][t] == 0) { noFill();}
     if (mix_type[i][t] == 1) { fill(convection);}
     if (mix_type[i][t] == 2) { noFill();}
     if (mix_type[i][t] == 3) { fill(overshoot);}
     if (mix_type[i][t] == 4) { fill(semiconv);}
     if (mix_type[i][t] == 5) { fill(thermohaline);}
     if (mix_type[i][t] == 6) { fill(rotation);}
      
     double x1 = starHeight*mix_qtop[i][t]*star_mass[t];
     double x0;
     if (i==0) { x0=0; }
     else {x0=starHeight*mix_qtop[i-1][t]*star_mass[t];}
     //println(z0,z1);
     pushMatrix();
     translate(starHeight/2-((float)x0+(float)x1)/2,(age-t)*cellheight,0);
     if (mix_qtop[i][t] < 1.0 && mix_type[i][t] > -1) {box((float)(x1-x0), cellheight, cellheight);}
     popMatrix();
   }
   }
   
   for (int i=0; i<numBurnRegions; i++) {
     if (abs(age-t) < 100) {
      if (burn_type[i][t] <= -0.01 && burn_type[i][t] > -10) { fill(cooling); }
      else if (burn_type[i][t] == 0) { noFill(); noStroke();}
      else {burnColor = lerpColor(minburncolor, maxburncolor, (float)((burn_type[i][t]-minburn)/(maxburn-minburn)));
      fill(burnColor);
      strokeWeight(1);
      stroke(0);
      //println((burn_type[i][t]-minburn)/(maxburn-minburn));
      }
      double x1 = starHeight*burn_qtop[i][t]*star_mass[t];
      double x0;
      if (i==0) { x0=0; }
      else {x0=starHeight*burn_qtop[i-1][t]*star_mass[t];}
      pushMatrix();
      translate(starHeight/2-((float)x0+(float)x1)/2,(age-t)*cellheight,((float)burn_type[i][t]+5)*cellheight/5);
      //drawCylinder(30, 105 + (float)burn_type[i][t], (float)(x1-x0));
      box((float)(x1-x0), cellheight, cellheight);
      popMatrix();
    }
   }
   
  }
  
}

void surface() {
  int t = (int)age;
  temp = new float[numRows];
  temp[t] = (float)teff[t]/100;
  if (temp[t] < 66) {red = 255;}
  else {
    red = temp[t] - 60;
    red = 29.698727446 * pow(red, -0.1332047592);
    if (red < 0) { red = 0; }
    if (red > 255) { red = 255; }
  }
  if (temp[t] <= 66) {
    green = temp[t];
    green = 99.4708025861 * log(green) - 161.1195681661;
    if (green < 0) { green=0; }
    if (green > 255) { green=255; }}
  else {
    green = temp[t] - 60;
    green = 288.1221695283 * pow(green, -0.0755148492);
    if (green < 0) { green=0; }
    if (green > 255) { green=255; }
  }
  if (temp[t] >= 66) { blue = 255; }
  else {
    if (temp[t] <= 19) { blue = 0; }
    else { 
      blue = temp[t] - 10;
      blue = 138.5177312231 * log(blue) - 305.0447927307;
      if (blue < 0) { blue = 0; }
      if (blue > 255) {blue = 255; }
    }
  }
  pushMatrix();
  translate(0, (age-t)*cellheight, starHeight*3/4);
  //translate(450, 0, starHeight);
  rotateZ(-PI/2);
  surfaceColor = color(red,green,blue);
  fill(red,green,blue);
  //println(red,green,blue);
  strokeWeight(0.1);
  sphereDetail((int)(radius[t]));
  sphere(radius[t]*2);
  rotateZ(PI/2);
  popMatrix();
  
  pushMatrix();
  textSize(14);
  strokeWeight(1);
  stroke(255);
  translate(0, (age-t)*cellheight, starHeight*3/4);
  //translate(450, 0, starHeight);
  line(10,0,0,10,0,-10);
  line(50,0,0,50,0,-10);
  line(100,0,0,100,0,-10);
  line(200,0,0,200,0,-10);
  //line(400,0,0,400,0,-10);
  rotateX(-PI/2);
  text("10", 15,-10,0);
  text("50", 55,-10,0);
  text("100", 125,-10,0);
  text("200 R_sun", 225,-10,0);
  //text("400", 405,-10,0);
  rotateX(PI/2);
  popMatrix();
  
}


void backgroundWindColor() {
  if (mdot[t] < -10) { windcolor = #000000;} 
  else {
  background(map((float)mdot[t],-10,max_wind,0,255));
  }
}
  