Table table;
double[] star_age, star_mass;
float [] dt;
double[] lum, teff;
float[] mdot;
float[] burn_h, burn_he;
float[] h1_mass, he4_mass;
float[] c12_mass, o16_mass;

double[] he_core_mass, c_core_mass, o_core_mass, si_core_mass;
float[] radius;
float[] logTc;
float[] logRhoc;
float[] eps_nuc_c;
float log_eps;
int cols=19;
double[][] mix_type;
double[][] mix_qtop;

double[][] burn_type;
double[][] burn_qtop;

float min_h_burn, min_he_burn;
float max_h_burn, max_he_burn;
float max_wind;

int numRows;
int numCols;

int numMixRegions = 20;
int numBurnRegions = 40;

void readData() {
  table = loadTable("history.data","header, csv");

  numRows = table.getRowCount();
  
  numCols = table.getColumnCount();

  
  star_age = new double[numRows];
  star_mass = new double[numRows];
  dt = new float[numRows];
  mdot = new float[numRows];
  he_core_mass = new double[numRows];
  c_core_mass = new double[numRows];
  o_core_mass = new double[numRows];
  si_core_mass = new double[numRows];
  lum = new double[numRows];
  teff = new double[numRows];
  radius = new float[numRows];
  logTc = new float[numRows];
  logRhoc = new float[numRows];
  eps_nuc_c = new float[numRows];
  
  burn_h = new float[numRows];
  burn_he = new float[numRows];
  h1_mass = new float[numRows];
  he4_mass = new float[numRows];
  c12_mass = new float[numRows];
  o16_mass = new float[numRows];
  
  mix_type = new double[numMixRegions][numRows];
  mix_qtop = new double[numMixRegions][numRows];
  
  burn_type = new double[numBurnRegions][numRows];
  burn_qtop = new double[numBurnRegions][numRows];
  
  for (int i=0 ; i<numRows ; i++) {
    star_age[i] = table.getDouble(i,0);
    star_mass[i] = table.getDouble(i,1);
    //println(star_mass[i]);
    mdot[i] = table.getFloat(i,2);
    dt[i] = table.getFloat(i,3);
    he_core_mass[i] = table.getDouble(i,4);
    c_core_mass[i] = table.getDouble(i,5);
    o_core_mass[i] = table.getDouble(i,6);
    si_core_mass[i] = table.getDouble(i,7);
    burn_h[i] = table.getFloat(i,8);
    burn_he[i] = table.getFloat(i,9);

    lum[i] = table.getFloat(i,10);
    teff[i] = table.getFloat(i,11);
    radius[i] = table.getFloat(i,12);
    
    logTc[i] = table.getFloat(i,13);
    logRhoc[i] = table.getFloat(i,14);
    eps_nuc_c[i] = table.getFloat(i,15);
    
    h1_mass[i] = table.getFloat(i,16);
    he4_mass[i] = table.getFloat(i,17);
    c12_mass[i] = table.getFloat(i,18);
    o16_mass[i] = table.getFloat(i,19);
    
    //println(teff[i]);
    for (int j=cols; j<2*numMixRegions+cols; j=j+2) {
      mix_type[(j-cols)/2][i] = table.getDouble(i,j+1);
      //println(mix_type[(j-cols)/2][i]);
      mix_qtop[(j-cols)/2][i] = table.getDouble(i,j+2);
      //println(mix_qtop[(j-cols)/2][i]);
    }
    for (int j=cols+2*numMixRegions; j<2*numBurnRegions + 2*numMixRegions+cols; j=j+2) {
      burn_type[(j-cols-2*numMixRegions)/2][i] = table.getDouble(i,j+1);
      //println(burn_type[(j-cols-2*numMixRegions)/2][i]);
      burn_qtop[(j-cols-2*numMixRegions)/2][i] = table.getDouble(i,j+2);
    }
  }
  max_age = star_age[numRows-1];
  min_h_burn = -2;
  max_h_burn = max(burn_h);
  min_he_burn = -2;
  max_he_burn = max(burn_he);
  max_wind = max(mdot);
  
}